
function iselect=GDI_gdina(tposterior, K, Q,itempara,eligible, L, truea, truea_expand)

% select items using the GDI index with the ACDM model
% tposterior: 2^K by 1 vector of posterior probabilities
% K: total number of attributes measured by the entire test
% itempara: J-by-(K+1) vector of ACDM item parameters
% eligible: J-by-1 vector of whether an item is eligible or not (i.e.,
% already selected items are no longer eligible)
% truea: is a 2^K by K matrix, and the order of the rows match with the
% order of the rows of posterior

information=zeros(L,1);
for j=1:L
    if (eligible(j)==0)
        q=Q(j,1:K);
        index=find(q==1); % it tells which attributes are relevant
        kj=length(index);
        
        
        trueaj=zeros(2^kj,kj);
      
        a=[0;1];
        for k=1:kj
            true1=repmat(a,2^(k-1),2^(kj-k));
            trueaj(:,k)=reshape(true1',2^kj,1);
        end
        
        
        pij=zeros(2^kj,1);
        ccprob=zeros(2^kj,1); % correct response probability for each relevant pattern
        for k=1:2^kj
            temp=(truea(:, index)==trueaj(k,:));  % temp is a 2^K-by-kj logical matrix
            ttemp=sum(temp,2);
            tttemp=(ttemp==kj); % tttemp is a 2^K-by-1 logical matrix
            pij(k)=sum(tposterior(tttemp));
            check=find(tttemp==1);
            ccprob(k)=itempara(j,1:2^K)*truea_expand(check(1),:)';  % for truea_expand, those rows indicated by "check" should have the same relevant alphas for item j, so I pick the first one without 
            % loosing any information; even though the truea_expand (check)
            % will be different, those different elements correspond to 0
            % elements in itempara, so the probability does not change
        end
        pbar=pij'*ccprob;
        for k=1:2^kj
            information(j)=information(j)+pij(k)*(ccprob(k)-pbar).^2;
        end
    end
end
inter_step=find(information==max(information));
if (length(inter_step)==1)
    iselect=inter_step;
else
    iselect=randsample(inter_step,1);
end