function [estimate_a, post]=MAP_gdina_fast(select,K, resp, itempara,J, prior_post,truea)
% This is a fast version because it takes into account the previous
% posterior. So no need to start from all items 
% select: vector of selected items
% resp: the response vector for a person
% Q: q matrix for the items in item bank % we do not seem to need Q because
% in ACDM, the item parameter information already reflect Q information
% itempara: item parameters for the items in the bank
% J: current # of items selected so far
% prior: prior probabilities  1 by 2^K
% truea: it is a 2^K by K matrix
% etimate_a; is a 1 by K vector of the estimated (point estimate) profile
% post: is 2^K by 1 vector of posterior prob of each possible pattern
likelihood=ones(2^K,1);
%for j=1:J
j=J;
    for l=1:2^K
        cprob=itempara(select(j),:)*truea(l,:)';
        likelihood(l)=likelihood(l)*(cprob^resp(j)*(1-cprob)^(1-resp(j)));
    end
%end
post=likelihood.*prior_post./(prior_post'*likelihood);
inter_step=find(post==max(post));
if (length(inter_step)==1)
    estimate_a=truea(inter_step,:);
else
    select=randsample(inter_step,1);
    estimate_a=truea(select,:);
end

end