%% 4/30/2020  Simulation Study II K=10
% The hierarchical structure follows Figure 2b in the paper
% Update the code using GDINA model

clear all
clc
N=16800;
K1=5;
K=10;
truea1=zeros(2^K1,K1);
a=[0;1];
for k=1:K1
    true1=repmat(a,2^(k-1),2^(K1-k));
    truea1(:,k)=reshape(true1',2^K1,1);
end
prior1=ones(1,2^K1).*1/(2^K1);


% True alpha at time 1
true_alpha_t1=zeros(N,K1);
true_alpha_t1(:,1:K1)=repmat(truea1,525,1);  % 525=16800/2^K1
% True alpha at time 2
% Set up learning rate
learning=zeros(K,1);
forget=zeros(K1,1);
for k=1:K
   learning(k)=0.5;
end
for k=1:K1
  forget(k)=0.2;
end
true_alpha_t2=zeros(N,K);
for i=1:N
    for k=1:K1
        if(true_alpha_t1(i,k)==1)
           true_alpha_t2(i,k)=binornd(1,1-forget(k));
        end
        if(true_alpha_t1(i,k)==0)
            true_alpha_t2(i,k)=binornd(1,learning(k));
        end
    end
    if (true_alpha_t2(i,1)==1)
        true_alpha_t2(i,6)=binornd(1,learning(6));
    end
    if (true_alpha_t2(i,1)*true_alpha_t2(i,2)==1)
        true_alpha_t2(i,7)=binornd(1,learning(7));
    end
    if (true_alpha_t2(i,3)*true_alpha_t2(i,4)==1)
        true_alpha_t2(i,8)=binornd(1,learning(8));
    end
    if (true_alpha_t2(i,3)==1)
        true_alpha_t2(i,9)=binornd(1,learning(9));
    end
    if (true_alpha_t2(i,4)*true_alpha_t2(i,5)==1)
        true_alpha_t2(i,10)=binornd(1,learning(10));
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create 32*1024 transition matrix
truea2=zeros(2^K,K);  % all possible patterns
for k=1:K
    true1=repmat(a,2^(k-1),2^(K-k));
    truea2(:,k)=reshape(true1',2^K,1);
end
transitionm=zeros(2^K1,2^K);

for i=1:2^K1
    for j=1:2^K
        part1=1.0;
        for k=1:K1
            temp1=((1-forget(k))^truea1(i,k)*learning(k)^(1-truea1(i,k)))^truea2(j,k);
            temp2=(forget(k)^truea1(i,k)*(1-learning(k))^(1-truea1(i,k)))^(1-truea2(j,k));
            part1=part1*temp1*temp2;
        end
        part21=((learning(6)^truea2(j,1)*0^(1-truea2(j,1)))^truea2(j,6))*(((1-learning(6))^truea2(j,1)*1^(1-truea2(j,1)))^(1-truea2(j,6)));%alpha6
        part23=((learning(9)^truea2(j,3)*0^(1-truea2(j,3)))^truea2(j,9))*(((1-learning(9))^truea2(j,3)*1^(1-truea2(j,3)))^(1-truea2(j,9)));%alpha9
        part22=(learning(7)^(truea2(j,1)*truea2(j,2))*0^(2-truea2(j,1)-truea2(j,2)))^truea2(j,7)*((1-learning(7))^(truea2(j,1)*truea2(j,2)))^(1-truea2(j,7)); %alpha7
        part24=(learning(8)^(truea2(j,3)*truea2(j,4))*0^(2-truea2(j,3)-truea2(j,4)))^truea2(j,8)*((1-learning(8))^(truea2(j,3)*truea2(j,4)))^(1-truea2(j,8)); %alpha8
        part25=(learning(10)^(truea2(j,4)*truea2(j,5))*0^(2-truea2(j,4)-truea2(j,5)))^truea2(j,10)*((1-learning(10))^(truea2(j,4)*truea2(j,5)))^(1-truea2(j,10)); %alpha10
        transitionm(i,j)=part1*part21*part22*part23*part24*part25;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% create item bank, size=600
% No need to repeat for evaluating the current vs. new method (i.e., we
% want to keep item bank static)
K1=5;  % 5 attributes measured in stage I
% create q-matrix for the first stage: only measure a1~a3
% find q-vectors that measure 2 out of 5 attributes
combo1=combnk(1:K1,2);
leng=size(combo1);
temp=zeros(leng(1), K1);
for l=1:leng(1)
    temp(l, combo1(l,:))=1;
end

% find q-vectors that measure 3 out of 5 attributes
combo1=combnk(1:K1,3);
leng=size(combo1);
temp2=zeros(leng(1), K1);
for l=1:leng(1)
    temp2(l, combo1(l,:))=1;
end
qtest=[eye(K1);eye(K1);temp; temp2];

qk1=[qtest,zeros(size(qtest,1),size(qtest,2))];
trueq1=repmat(qk1,6,1); % the first 180 items only measure a1~a5
qk2=[zeros(size(qtest,1),size(qtest,2)), qtest];
trueq2=repmat(qk2,6,1); % the second 180 items only measure a6~a10

% create another 240 items measure a1~a10
trueq3=zeros(240,K);
for j=1:80
    temp1=randsample(1:5,1);
    temp2=randsample(6:10,1);
    trueq3(j,temp1)=1;
    trueq3(j,temp2)=1;
end
for j=81:160
    temp1=randsample(1:5,2);
    temp2=randsample(6:10,1);
    trueq3(j,temp1)=1;
    trueq3(j,temp2)=1;
end
for j=161:240
    temp1=randsample(1:5,1);
    temp2=randsample(6:10,2);
    trueq3(j,temp1)=1;
    trueq3(j,temp2)=1;
end

trueq=[trueq1;trueq2;trueq3];
L=size(trueq,1);
%
% Generate GDINA item parameters
itempara=zeros(L,2^K);
itempara(:,1)=unifrnd(0.01,0.3,[L,1]); % intercept
highest_prob=zeros(L,1);
highest_prob=unifrnd(0.7,1,[L,1]); % highest correct response prob (assuming someone masters all required attributes)
expand_trueq=zeros(L, 2^K);
for j=1:L
    expand_trueq(j,:)=expand(trueq(j,:),K);
end
for j=1:L
    tq=sum(expand_trueq(j,:))-1;
    index=find(expand_trueq(j,2:2^K)==1);
    itempara(j,index+1)=(highest_prob(j)-itempara(j,1))/tq+unifrnd(-0.05,0.05,[1,tq]);
%     if sum(itempara(j,:))<(highest_prob(j)-itempara(j,1))
%         itempara(j,index)=itempara(j,index)+(highest_prob(j)-itempara(j,1)-sum(itempara(j,:)))./tq;
%     end
    if sum(itempara(j,:))>1
        itempara(j,index+1)=itempara(j,index+1)-(sum(itempara(j,:))-1)./tq;
    end
    temp=find(itempara(j,:)<0);
    if length(temp)>0
        itempara(j, temp)=0.01;
    end
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     CD-CAT Begin
%%%%%%%%%%%Stage I%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
K1=5;
L1=180; % stage I cd-cat will only use the first 150 items
% To enusre fair comparison between the different item selection methods,
% we fix the responses
truealpha=true_alpha_t1;
sresponse=zeros(N,L1); % set the response matrix

truealpha1_expand=zeros(N,2^K1);
for i=1:N
    truealpha1_expand(i,:)=expand(truealpha(i,1:K1),K1);
end

for i=1:N
    for j=1:L1
        cprob=itempara(j,1:2^K1)*truealpha1_expand(i,:)';
        temp=rand;
        if(cprob>=temp)
            sresponse(i,j)=1;
        end
    end
end

sitempara=itempara(1:L1,1:2^K1);
strueq=trueq(1:L1,1:K1);
J=6;
item_expose=zeros(L1,1);
response=zeros(N,J);
est_alpha=zeros(N,K1);
posterior=zeros(2^K1,N);
item_select=zeros(N,J);

%%%%%%%%%%%%expand truea1
truea1_expand=zeros(2^K1, 2^K1);
for i=1:2^K1
    truea1_expand(i,:)=expand(truea1(i,:),K1);
end

for i=1:N
    test=0;
    eligible=zeros(L1,1);
    select=zeros(J,1);
    select(1)=floor(rand*L1)+1;
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    [temp_alpha, temp_posterior]=MAP_gdina(select,K1, response(i,1), sitempara,1, prior1,truea1_expand);
    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
        select(j)=GDI_gdina(temp_posterior, K1, strueq,sitempara,eligible, L1, truea1, truea1_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K1, response(i,1:test), sitempara,test, temp_posterior,truea1_expand);    
    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K1, response(i,1:J), sitempara,J, temp_posterior,truea1_expand);
    est_alpha(i,1:K1)=reduce(temp_alpha,K1);
end
%
% Pattern recovery rate
count=0;
for i=1:N
    if (sum(abs(est_alpha(i,1:K1)-truealpha(i,1:K1)))==0)
        count=count+1;
    end
end
count/N

% Attribute recovery rate
attribute_recovery=zeros(K1,1);
for k=1:K1
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery

stage1est=est_alpha(1:N, 1:K1);

stage1posterior=posterior;
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Stage II 
ptruea=csvread('permissible10.csv');  %there are 168 permissible patterns!
nperm=size(ptruea,1); % number of permissible patterns
K=10;
truea=zeros(2^K,K);
a=[0;1];
for k=1:K
    true1=repmat(a,2^(k-1),2^(K-k));
    truea(:,k)=reshape(true1',2^K,1);
end
check=zeros(1,2^K);
for l=1:nperm
    [q,idx]=ismember(ptruea(l,:),truea,'rows');
    check(idx)=1;
end
prior12=check.*1/nperm;  % prior for both stages, taking into account attribute hierarchies

newposterior=zeros(2^K,N);
for i=1:N
    newposterior(:,i)=(stage1posterior(:,i)'*transitionm)';
end
truealpha=true_alpha_t2;

J=20;
item_expose=zeros(L,1);
response=zeros(N,J);
est_alpha=zeros(N,K);
posterior=zeros(2^K,N);
item_select=zeros(N,J);

truealpha_expand=zeros(N,2^K);
for i=1:N
    truealpha_expand(i,:)=expand(truealpha(i,1:K),K);
end
%%%%%%%%%%%%expand truea
truea_expand=zeros(2^K, 2^K);
for i=1:2^K
    truea_expand(i,:)=expand(truea(i,:),K);
end

sresponse=zeros(N,L); % set the response matrix
for i=1:N
    for j=1:L
        %cprob=itempara(j,:)*[1,truealpha(i,:)]';
        cprob=itempara(j,:)*truealpha_expand(i,:)';
        temp=rand;
        if(cprob>=temp)
            sresponse(i,j)=1;
        end
    end
end
%%
%
groupposterior=ones(1,2^K1).*(1/2^K1)*transitionm;
for i=1:N
    test=0;
    eligible=zeros(L,1);
  %  eligible(1:L1)=1;  % the first L1 items are no longer eligible
    select=zeros(J,1);
    select(1)=randsample((L1+1):L,1);
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    
    [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, newposterior(:,i)',truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, prior12,truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, groupposterior,truea_expand);

    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
         select(j)=GDI_gdina(temp_posterior, K, trueq,itempara,eligible, L, truea, truea_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K, response(i,1:test), itempara,test, temp_posterior,truea_expand);

    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K, response(i,1:J), itempara,J, temp_posterior,truea_expand);
    est_alpha(i,:)=reduce(temp_alpha,K);
end

count=0;
for i=1:N
    if (sum(abs(est_alpha(i,:)-truealpha(i,:)))==0)
        count=count+1;
    end
end
count/N
attribute_recovery=zeros(K,1);
for k=1:K
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery
save('Study II_K=10_hierarchical_GDINA_non-restricted_low-learning_individual')

for i=1:N
    test=0;
    eligible=zeros(L,1);
  %  eligible(1:L1)=1;  % the first L1 items are no longer eligible
    select=zeros(J,1);
    select(1)=randsample((L1+1):L,1);
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, newposterior(:,i)',truea_expand);
    [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, prior12,truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, groupposterior,truea_expand);

    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
         select(j)=GDI_gdina(temp_posterior, K, trueq,itempara,eligible, L, truea, truea_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K, response(i,1:test), itempara,test, temp_posterior,truea_expand);

    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K, response(i,1:J), itempara,J, temp_posterior,truea_expand);
    est_alpha(i,:)=reduce(temp_alpha,K);
end

count=0;
for i=1:N
    if (sum(abs(est_alpha(i,:)-truealpha(i,:)))==0)
        count=count+1;
    end
end
count/N
attribute_recovery=zeros(K,1);
for k=1:K
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery
save('Study II_K=10_hierarchical_GDINA_non-restricted_low-learning_baseline')

for i=1:N
    test=0;
    eligible=zeros(L,1);
  %  eligible(1:L1)=1;  % the first L1 items are no longer eligible
    select=zeros(J,1);
    select(1)=randsample((L1+1):L,1);
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, newposterior(:,i)',truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, prior12,truea_expand);
    [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, groupposterior,truea_expand);

    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
         select(j)=GDI_gdina(temp_posterior, K, trueq,itempara,eligible, L, truea, truea_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K, response(i,1:test), itempara,test, temp_posterior,truea_expand);

    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K, response(i,1:J), itempara,J, temp_posterior,truea_expand);
    est_alpha(i,:)=reduce(temp_alpha,K);
end

count=0;
for i=1:N
    if (sum(abs(est_alpha(i,:)-truealpha(i,:)))==0)
        count=count+1;
    end
end
count/N
attribute_recovery=zeros(K,1);
for k=1:K
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery
save('Study II_K=10_hierarchical_GDINA_non-restricted_low-learning_group')


for i=1:N
    test=0;
    eligible=zeros(L,1);
    eligible(1:L1)=1;  % the first L1 items are no longer eligible
    select=zeros(J,1);
    select(1)=randsample((L1+1):L,1);
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, newposterior(:,i)',truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, prior12,truea_expand);
    [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, groupposterior,truea_expand);

    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
         select(j)=GDI_gdina(temp_posterior, K, trueq,itempara,eligible, L, truea, truea_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K, response(i,1:test), itempara,test, temp_posterior,truea_expand);

    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K, response(i,1:J), itempara,J, temp_posterior,truea_expand);
    est_alpha(i,:)=reduce(temp_alpha,K);
end

count=0;
for i=1:N
    if (sum(abs(est_alpha(i,:)-truealpha(i,:)))==0)
        count=count+1;
    end
end
count/N
attribute_recovery=zeros(K,1);
for k=1:K
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery
save('Study II_K=10_hierarchical_GDINA_restricted_low-learning_group')


for i=1:N
    test=0;
    eligible=zeros(L,1);
    eligible(1:L1)=1;  % the first L1 items are no longer eligible
    select=zeros(J,1);
    select(1)=randsample((L1+1):L,1);
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, newposterior(:,i)',truea_expand);
    [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, prior12,truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, groupposterior,truea_expand);

    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
         select(j)=GDI_gdina(temp_posterior, K, trueq,itempara,eligible, L, truea, truea_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K, response(i,1:test), itempara,test, temp_posterior,truea_expand);

    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K, response(i,1:J), itempara,J, temp_posterior,truea_expand);
    est_alpha(i,:)=reduce(temp_alpha,K);
end

count=0;
for i=1:N
    if (sum(abs(est_alpha(i,:)-truealpha(i,:)))==0)
        count=count+1;
    end
end
count/N
attribute_recovery=zeros(K,1);
for k=1:K
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery
save('Study II_K=10_hierarchical_GDINA_restricted_low-learning_baseline')


for i=1:N
    test=0;
    eligible=zeros(L,1);
    eligible(1:L1)=1;  % the first L1 items are no longer eligible
    select=zeros(J,1);
    select(1)=randsample((L1+1):L,1);
    eligible(select(1))=1;
    test=test+1;
    response(i,1)=sresponse(i,select(1));
    
    [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, newposterior(:,i)',truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, prior12,truea_expand);
  %  [temp_alpha, temp_posterior]=MAP_gdina(select,K, response(i,1), itempara,1, groupposterior,truea_expand);

    item_expose(select(1))=item_expose(select(1))+1;
    for j=2:J
         select(j)=GDI_gdina(temp_posterior, K, trueq,itempara,eligible, L, truea, truea_expand);
        eligible(select(j))=1;
        item_expose(select(j))=item_expose(select(j))+1;
        test=test+1;
        response(i,j)=sresponse(i,select(j));
        [temp_alpha, temp_posterior]=MAP_gdina_fast(select(1:test),K, response(i,1:test), itempara,test, temp_posterior,truea_expand);

    end
    item_select(i,:)=select';
    [temp_alpha, posterior(:,i)]=MAP_gdina_fast(select,K, response(i,1:J), itempara,J, temp_posterior,truea_expand);
    est_alpha(i,:)=reduce(temp_alpha,K);
end

count=0;
for i=1:N
    if (sum(abs(est_alpha(i,:)-truealpha(i,:)))==0)
        count=count+1;
    end
end
count/N
attribute_recovery=zeros(K,1);
for k=1:K
    attribute_recovery(k)=sum(est_alpha(1:N,k)==truealpha(1:N,k))/N;
end
attribute_recovery
save('Study II_K=10_hierarchical_GDINA_restricted_low-learning_individual')
