function [expanded_v]=expand(vector, K)
% it is a function to expand a binary 1-by-K vector to 1-by-2^K
% vector is a 1-by-K vector
% expanded_v is a 1-by-2^K vector in the following order
% intercept, a1, a2, a12, a3, a13, a23, a123, a4, a14, a24, a124, a34,
% a134, a234, a1234....
% K>=3
expanded_v=zeros(1,2^K);

expanded_v(1)=1;
expanded_v(2:3)=vector(1:2); %alpha1, alpha2 
expanded_v(4)=vector(1)*vector(2);
for k=3:K
    expanded_v((2^(k-1)+1):2^k)=vector(k).*expanded_v(1:2^(k-1));
end